<template>
  <div class="app-container calendar-list-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input clearable class="filter-item" style="width: 200px;" placeholder="请输入用户名" v-model="listQuery.userName">
      </el-input>
      <el-input clearable class="filter-item" style="width: 200px;" placeholder="请输入手机号" v-model="listQuery.phone">
      </el-input>
      <el-select v-model="listQuery.temRoleType" clearable placeholder="请选择角色" style="top: -4px;width: 200px;">
        <el-option label="在校生" value="在校生">
        </el-option>
        <el-option label="校友" value="校友">
        </el-option>
        <el-option label="教师" value="教师">
        </el-option>
        <el-option label="非清华公管人" value="非清华公管人">
        </el-option>
        <el-option label="游客" value="游客">
        </el-option>
      </el-select>
      <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button class="filter-item" type="primary" :loading="downloadLoading" v-waves icon="el-icon-download" @click="handleDownload">导出</el-button>
      <el-button class="filter-item" type="primary" icon="" @click="showAuditDialog" >批量审核</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table size="small" :data="list" v-loading="listLoading" @selection-change="handleSelectionChange" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column type="selection" align="center">
      </el-table-column>

      <!--<el-table-column align="center" width="100px" label="用户ID" prop="id" sortable>
      </el-table-column>-->
      <el-table-column type="index" label="序号" header-align="center" align="center">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="头像" prop="photo">
        <template slot-scope="scope">
          <img :src="scope.row.photo" style="width: 50px;height: 50px;border-radius: 50%"/>
        </template>
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="用户名" prop="userName">
      </el-table-column>

      <el-table-column align="center" min-width="50px" label="性别" prop="gender">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="手机号" prop="phone">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="邮箱" prop="email">
      </el-table-column>


      <!--<el-table-column align="center" min-width="100px" label="学院" prop="school">
      </el-table-column>-->

      <el-table-column align="center" min-width="100px" label="学历" prop="degree">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="导师" prop="guider">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="申请角色" prop="temRoleType">
      </el-table-column>

      <el-table-column align="center" min-width="100px" label="注册时间" prop="createDate">
      </el-table-column>

      <el-table-column align="center" label="操作" width="200" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button type="primary" size="mini" @click="auditUser(scope.row)">审核</el-button>

          <router-link ref='tag' :to="{path:'/user/userDetail',query: {'id': scope.row.id}}">
            <el-button class="filter-item" type="primary" size="mini" style="width: inherit;" v-waves icon="el-icon-search">用户详情</el-button>
          </router-link>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <div class="pagination-container">
      <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="listQuery.page"
                     :page-sizes="[10,20,30,50]" :page-size="listQuery.limit" layout="total, sizes, prev, pager, next, jumper" :total="total">
      </el-pagination>
    </div>

    <!-- 审核用户对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="100px" style='width: 400px; margin-left:50px;'>

        <el-form-item :rules="rules"  label="审核：" prop="auditStatus">
          <div>
            <el-radio v-model="dataForm.auditStatus" label="3" border>通过</el-radio>
            <el-radio v-model="dataForm.auditStatus" label="2" border>驳回</el-radio>
          </div>
        </el-form-item>
        <template v-if="dataForm.auditStatus=='2'">
          <el-form-item label="驳回原因：" prop="reason">
            <el-input type="textarea"
                      :rows="2"
                      placeholder="请输入内容"
                      v-model="dataForm.reason"></el-input>
          </el-form-item>
        </template>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='audit'" type="primary" @click="updateData">确定</el-button>
        <el-button v-if="dialogStatus=='auditDX'" type="primary" @click="passAudit">确定</el-button>


      </div>
    </el-dialog>


  </div>
</template>

<script>
import { fetchCheckUserList, passUserAudit, auditUser } from '@/api/user'
import waves from '@/directive/waves' // 水波纹指令

export default {
  name: 'checkUser',
  directives: {
    waves
  },
  data() {
    return {
      list: null,
      total: null,
      listLoading: true,
      listQuery: {
        page: 1,
        limit: 20,
        userName: undefined,
        phone: undefined,
        temRoleType:undefined,
        sort: '+id'
      },
      dataForm: {
        id: undefined,
        selectedIDs: '',
        auditStatus: '',
        reason: ''
      },
      rules: {
        auditStatus: [{ required: true, message: '不能为空', trigger: 'blur' }]
      },
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        audit: ' 审核',
        auditDX: '批量审核'
      },
      multipleSelection: [],
      downloadLoading: false
    }
  },
  filters: {
  },
  created() {
    this.getList()
  },
  methods: {
    getList() {
      this.listLoading = true
      fetchCheckUserList(this.listQuery).then(response => {
        this.list = response.data.data.items
        console.log(this.list)
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.getList()
    },
    handleCurrentChange(val) {
      this.listQuery.page = val
      this.getList()
    },
    auditUser(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'audit'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          auditUser(this.dataForm).then(response => {
            this.dialogFormVisible = false
            var state = response.data.data.state
            if (state === 'success') {
              this.getList()
              this.$notify({
                title: '校友认证审核',
                message: '操作成功',
                type: 'success',
                duration: 2000
              })
            }
          })
        }
      })
    },
    showAuditDialog() {
      if (this.dataForm.selectedIDs.length > 0) {
        var ids = this.dataForm.selectedIDs
        console.log(ids)
        this.dialogStatus = 'auditDX'
        this.dialogFormVisible = true
      } else {
        this.$notify.error({
          title: '校友认证审核',
          message: '请至少选择一条记录',
          duration: 2000
        })
      }
    },
    passAudit() {
      if (this.dataForm.selectedIDs.length > 0) {
        debugger
        console.log(this.dataForm.selectedIDs)
        passUserAudit(this.dataForm).then(response => {
          this.dialogFormVisible = false
          var state = response.data.data.state
          if (state === 'success') {
            this.getList()
            this.$notify({
              title: '校友认证审核',
              message: '审核成功',
              type: 'success',
              duration: 2000
            })
          }
        }).catch(() => {
          this.$notify.error({
            title: '校友认证审核',
            message: '审核失败',
            duration: 2000
          })
        })
      } else {
        this.$notify.error({
          title: '校友认证审核',
          message: '请至少选择一条记录',
          duration: 2000
        })
      }
    },
    handleSelectionChange(val) {
      var ids = []
      this.multipleSelection = val
      this.multipleSelection.map((item) => {
        console.log(item.id)
        ids.push(item.id)
      })

      this.dataForm.selectedIDs = ids.join(',')
      console.log('多选' + this.dataForm.selectedIDs)
    },
    handleDownload() {
      this.downloadLoading = true
      import('@/vendor/Export2Excel').then(excel => {
        const tHeader = ['用户名','性别',  '学历', '导师', '手机号码','邮箱', '入学时间','申请角色' ,'工作单位', '职位', '所在地']
        const filterVal = ['userName', 'gender', 'degree', 'guider', 'phone','email', 'beginDate','temRoleType', 'working', 'position','place']
        excel.export_json_to_excel2(tHeader, this.list, filterVal, '待审核认证用户信息')
        this.downloadLoading = false
      })
    }
  }
}
</script>

<style scoped>

</style>
